<?php

$plugin_info = array(
						'pi_name'			=> 'Recently Commented Entries',
						'pi_version'		=> '3.3.3',
						'pi_author'			=> 'Yoshi Melrose',
						'pi_author_url'		=> 'http://www.psychodaisy.com/',
						'pi_description'	=> 'Shows the # entries with the latest comments in your blog.',
						'pi_usage'			=> Recentcomments::usage()
					);




class Recentcomments {

	var $return_data;

    var $safe_decode = array(
                                'b'             => 'b', 
                                'i'             => 'i',
                                'u'             => 'u', 
                                'em'            => 'em', 
                                'strike'        => 'strike', 
                                'strong'        => 'strong', 
                                'pre'           => 'pre', 
                                'code'          => 'pre', 
                                'blockquote'    => 'blockquote',
                                'quote'         => 'quote'
                             );
	
	function Recentcomments()
	{
        global $DB, $TMPL, $FNS, $PREFS, $LOC;

        if ( ! class_exists('Typography'))
        {
            require PATH_CORE.'core.typography'.EXT;
        }
                
        $TYPE = new Typography(0); 

		$weblogname=(!$TMPL->fetch_param('weblog')) ? "weblog1" : $TMPL->fetch_param('weblog');
		$datetimeformat=(!$TMPL->fetch_param('format')) ? "%m/%d/%y %H:%i" : $TMPL->fetch_param('format');
		$entrylimit=(!$TMPL->fetch_param('limit')) ? "5" : $TMPL->fetch_param('limit');
		$totalwords=(!$TMPL->fetch_param('totalwords')) ? 5 : $TMPL->fetch_param('totalwords');
		$type=(!$TMPL->fetch_param('type')) ? "entries" : $TMPL->fetch_param('type');
		$results="";
		
		if ($type == "trackbacks")
		{
			$str = $FNS->sql_andor_string($weblogname, 'blog_name');
			if (substr($str, 0, 3) == 'AND')
				$str = substr($str, 3);
			$sql="select weblog_id,comment_text_formatting from exp_weblogs where ".$str;
			$query = $DB->query($sql);
			if ($query->num_rows == 0)
				return false;
			$newstr="";
			foreach($query->result as $id)
			{
				$newstr.="weblog_id = ".$id['weblog_id']." OR ";
			}
			$newstr=substr($newstr,0,strlen($newstr)-4);
			$weblog_id=$query->result[0]['weblog_id'];
			$text_formatting=$query->result[0]['comment_text_formatting'];
			
			$sql="select entry_id,trackback_id,title,content,trackback_date,trackback_url,weblog_name from exp_trackbacks where ".$newstr." order by trackback_date desc limit 0,$entrylimit";
			$query=$DB->query($sql);
			if ($query->num_rows == 0)
				return false;
			foreach($query->result as $row)
			{
				$sql="select entry_id from exp_trackbacks where entry_id=".$row['entry_id'];
				$totalcount=$DB->query($sql);
				$totalcount=$totalcount->num_rows;
				$sql="select title,url_title from exp_weblog_titles where entry_id=".$row['entry_id'];
				$titleresult=$DB->query($sql);
				$title=$titleresult->result[0]['title'];
				$url_title=$titleresult->result[0]['url_title'];
				if(empty($row['trackback_url']) || $row['trackback_url']=="http://")
					$author=$row['weblog_name'];
				else
				{
					$new_url=eregi("http://",$row['trackback_url']) ? $row['trackback_url'] : "http://".$row['trackback_url'];
					$author="<a href=\"".$new_url."\">".$row['weblog_name']."</a>";
				}
				$tagdata =& $TMPL->tagdata;
				foreach ($TMPL->var_single as $key => $val)
				{
					if (eregi("^author", $key))
					{
						$tagdata =& $TMPL->swap_var_single(
															$key,
															$author,
															$tagdata);
					}
					if (eregi("^title_permalink", $key))
					{                     
						if ($FNS->extract_path($key) != '' AND $FNS->extract_path($key) != 'SITE_INDEX')
						{
							$path = $FNS->extract_path($key).'/'.$url_title;
						}
						else
						{
							$path = $url_title;
						}
					
						$tagdata =& $TMPL->swap_var_single(
															$key, 
															$FNS->create_url($path, 1, 0), 
															$tagdata
														 );
					}
					if (eregi("^permalink", $key))
					{                     
						if ($FNS->extract_path($key) != '' AND $FNS->extract_path($key) != 'SITE_INDEX')
						{
							$path = $FNS->extract_path($key).'/'.$row['entry_id'];
						}
						else
						{
							$path = $row['entry_id'];
						}
					
						$tagdata =& $TMPL->swap_var_single(
															$key, 
															$FNS->create_url($path, 1, 0), 
															$tagdata
														 );
					}
					if (eregi("^date", $key))
					{
						$tagdata =& $TMPL->swap_var_single(
															$key,
															$LOC->decode_date($datetimeformat,$row['trackback_date']),
															$tagdata);
					}
					if (eregi("^trackback_id", $key))
					{
						$tagdata =& $TMPL->swap_var_single(
															$key,
															$row["trackback_id"],
															$tagdata);
					}
					if (eregi("^comment", $key))
					{
						$tagdata =& $TMPL->swap_var_single(
															$key,
															$FNS->word_limiter(strip_tags($this->strip_pmcode($row['content'])),$totalwords),
															$tagdata);
					}
					if (eregi("^total_comments", $key))
					{
						$tagdata =& $TMPL->swap_var_single(
															$key,
															$totalcount,
															$tagdata);
					}
					if (eregi("^title", $key))
					{
						$tagdata =& $TMPL->swap_var_single(
															$key,
															$title,
															$tagdata);
					}
					if (isset($row[$val]))
					{
						$tagdata =& $TMPL->swap_var_single($val, $row[$val], $tagdata);
					}		
				}
				$results.=$tagdata;
			}
			$this->return_data=$results;
		}
		else if ($type == "comments")
		{
			$str = $FNS->sql_andor_string($weblogname, 'blog_name');
			if (substr($str, 0, 3) == 'AND')
				$str = substr($str, 3);
			$sql="select weblog_id,comment_text_formatting from exp_weblogs where ".$str;
			$query = $DB->query($sql);
			if ($query->num_rows == 0)
				return false;
			$newstr="";
			foreach($query->result as $id)
			{
				$newstr.="weblog_id = ".$id['weblog_id']." OR ";
			}
			$newstr=substr($newstr,0,strlen($newstr)-4);
			$weblog_id=$query->result[0]['weblog_id'];
			$text_formatting=$query->result[0]['comment_text_formatting'];
			$sql="select entry_id,comment_id,name,comment,comment_date,url,location from exp_comments where ".$newstr." and status='o' order by comment_date desc limit 0,$entrylimit";
			$query=$DB->query($sql);
			if ($query->num_rows == 0)
				return false;
			foreach($query->result as $row)
			{
				$sql="select entry_id from exp_comments where entry_id=".$row['entry_id']." AND status='o'";
				$totalcount=$DB->query($sql);
				$totalcount=$totalcount->num_rows;
				$sql="select title,url_title from exp_weblog_titles where entry_id=".$row['entry_id'];
				$titleresult=$DB->query($sql);
				$title=$titleresult->result[0]['title'];
				$url_title=$titleresult->result[0]['url_title'];
				if(empty($row['url']) || $row['url']=="http://")
					$author=$row['name'];
				else
				{
					$new_url=eregi("http://",$row['url']) ? $row['url'] : "http://".$row['url'];
					$author="<a href=\"".$new_url."\">".$row['name']."</a>";
				}
				$tagdata =& $TMPL->tagdata;
				foreach ($TMPL->var_single as $key => $val)
				{
					if (eregi("^author", $key))
					{
						$tagdata =& $TMPL->swap_var_single(
															$key,
															$author,
															$tagdata);
					}
					if (eregi("^title_permalink", $key))
					{                     
						if ($FNS->extract_path($key) != '' AND $FNS->extract_path($key) != 'SITE_INDEX')
						{
							$path = $FNS->extract_path($key).'/'.$url_title;
						}
						else
						{
							$path = $url_title;
						}
					
						$tagdata =& $TMPL->swap_var_single(
															$key, 
															$FNS->create_url($path, 1, 0), 
															$tagdata
														 );
					}
					if (eregi("^permalink", $key))
					{                     
						if ($FNS->extract_path($key) != '' AND $FNS->extract_path($key) != 'SITE_INDEX')
						{
							$path = $FNS->extract_path($key).'/'.$row['entry_id'];
						}
						else
						{
							$path = $row['entry_id'];
						}
					
						$tagdata =& $TMPL->swap_var_single(
															$key, 
															$FNS->create_url($path, 1, 0), 
															$tagdata
														 );
					}
					if (eregi("^date", $key))
					{
						$tagdata =& $TMPL->swap_var_single(
															$key,
															$LOC->decode_date($datetimeformat,$row['comment_date']),
															$tagdata);
					}
					if (eregi("^comment_id", $key))
					{
						$tagdata =& $TMPL->swap_var_single(
															$key,
															$row["comment_id"],
															$tagdata);
					}
					if (eregi("^comment", $key))
					{
						$tagdata =& $TMPL->swap_var_single(
															$key,
															$FNS->word_limiter(strip_tags($this->strip_pmcode($row['comment'])),$totalwords),
															$tagdata);
					}
					if (eregi("^total_comments", $key))
					{
						$tagdata =& $TMPL->swap_var_single(
															$key,
															$totalcount,
															$tagdata);
					}
					if (eregi("^title", $key))
					{
						$tagdata =& $TMPL->swap_var_single(
															$key,
															$title,
															$tagdata);
					}
					if (isset($row[$val]))
					{
						$tagdata =& $TMPL->swap_var_single($val, $row[$val], $tagdata);
					}		
				}
				$results.=$tagdata;
			}
			$this->return_data=$results;
		}
		else
		{
			$str = $FNS->sql_andor_string($weblogname, 'blog_name');
			if (substr($str, 0, 3) == 'AND')
				$str = substr($str, 3);
			$sql="select entry_id,title,url_title,exp_weblogs.comment_text_formatting from exp_weblog_titles inner join exp_weblogs on exp_weblog_titles.weblog_id=exp_weblogs.weblog_id where ".$str." AND comment_total > 0 order by recent_comment_date desc limit 0,$entrylimit";
			$query = $DB->query($sql);
			if ($query->num_rows == 0)
				return false;
	
			foreach($query->result as $row)
			{
				$entry_id=$row['entry_id'];
				$text_formatting=$row['comment_text_formatting'];
				$sql="select comment_id,name,comment,comment_date,url,location from exp_comments where entry_id=$entry_id AND status='o' order by comment_date desc limit 0,1";
				$query2=$DB->query($sql);
	
				foreach($query2->result as $row2)
				{
					if(empty($row2['url']) || $row2['url']=="http://")
						$author=$row2['name'];
					else
					{
						$new_url=eregi("http://",$row2['url']) ? $row2['url'] : "http://".$row2['url'];
						$author="<a href=\"".$new_url."\">".$row2['name']."</a>";
					}
					$sql="select comment from exp_comments where entry_id=$entry_id order by comment_date desc";
					$query3=$DB->query($sql);
	
					$tagdata =& $TMPL->tagdata;
					foreach ($TMPL->var_single as $key => $val)
					{
						if (eregi("^author", $key))
						{
							$tagdata =& $TMPL->swap_var_single(
																$key,
																$author,
																$tagdata);
						}
						if (eregi("^title_permalink", $key))
						{                     
							if ($FNS->extract_path($key) != '' AND $FNS->extract_path($key) != 'SITE_INDEX')
							{
								$path = $FNS->extract_path($key).'/'.$row['url_title'];
							}
							else
							{
								$path = $row['url_title'];
							}
						
							$tagdata =& $TMPL->swap_var_single(
																$key, 
																$FNS->create_url($path, 1, 0), 
																$tagdata
															 );
						}
						if (eregi("^permalink", $key))
						{                     
							if ($FNS->extract_path($key) != '' AND $FNS->extract_path($key) != 'SITE_INDEX')
							{
								$path = $FNS->extract_path($key).'/'.$row['entry_id'];
							}
							else
							{
								$path = $row['entry_id'];
							}
						
							$tagdata =& $TMPL->swap_var_single(
																$key, 
																$FNS->create_url($path, 1, 0), 
																$tagdata
															 );
						}
						if (eregi("^date", $key))
						{
							$tagdata =& $TMPL->swap_var_single(
																$key,
																$LOC->decode_date($datetimeformat,$row2['comment_date']),
																$tagdata);
						}
						if (eregi("^comment_id", $key))
						{
							$tagdata =& $TMPL->swap_var_single(
																$key,
																$row2["comment_id"],
																$tagdata);
						}
						if (eregi("^comment", $key))
						{
							$tagdata =& $TMPL->swap_var_single(
																$key,
																$FNS->word_limiter(strip_tags($this->strip_pmcode($row2['comment'])),$totalwords),
																$tagdata);
						}
						if (eregi("^total_comments", $key))
						{
							$tagdata =& $TMPL->swap_var_single(
																$key,
																$query3->num_rows,
																$tagdata);
						}
						if (eregi("^title", $key))
						{
							$tagdata =& $TMPL->swap_var_single(
																$key,
																$row["title"],
																$tagdata);
						}
						if (isset($row2[$val]))
						{
							$tagdata =& $TMPL->swap_var_single($val, $row2[$val], $tagdata);
						}		
					}
					$results.=$tagdata;
				}
			}
			$this->return_data=$results;
		}
	}


	// Modified the "decode_pmcode" function within the typography class.
    function strip_pmcode(&$str)
    {
		foreach($this->safe_decode as $key => $val)
		{
			$str = preg_replace("#\[".$key."\](.+?)\[/".$key."\]#si", "\\1", $str);
		}
		$str = preg_replace("/\[color=(.*?)\](.*?)\[\/color\]/si", "\\2", $str);
		$str = preg_replace("/\[size=(.*?)\](.*?)\[\/size\]/si", "\\2", $str);
		/*
		$str = preg_replace("/\[url=www\.(.*?)\]/i", "[url=http://www.\\1]", $str);
		$str = preg_replace("/\[url=\"www\.(.*?)\]/i", "[url=\"http://www.\\1]", $str);
		$str = preg_replace("/\[url]www\.(.*?)\[\/url]/i", "[url]http://www.\\1[/url]", $str);
		*/
		
		$str = preg_replace("/\[url=\"(.*?)\](.*?)\[\/url\]/i", "\\2", $str);
		$str = preg_replace("/\[url=(.*?)\](.*?)\[\/url\]/i", "\\2", $str);
		$str = preg_replace("/\[url](.*?)\[\/url\]/i", "\\2", $str);
		$str = preg_replace("/\[img\](.*?)\[\/img\]/i", "\\1", $str);
		$str = preg_replace("/\[style=(.*?)\](.*?)\[\/style\]/si", "\\2", $str);    
		return $str;
    }



// ----------------------------------------
//  Plugin Usage
// ----------------------------------------

// This function describes how the plugin is used.
//  Make sure and use output buffering

function usage()
{
ob_start(); 
?>
Enhanced by CHOI Jae-Hoon(http://www.kaistizen.net)
	Jae-Hoon add some code to display recent tracksbacks.

BASIC USAGE:

{exp:recentcomments}
{/exp:recentcomments}


PARAMETERS:

weblog=
	weblog="weblog1" (default)
	Choose the weblog name that you wish to display for. i.e. weblog1, weblog2.
	You can also pipe different weblogs. i.e. weblog1 | weblog2.

limit=
	limit="5" (default)
	Choose the number of entries to show that has been recently commented on. i.e. limit="5" shows 5 entries.
	If used in type="comments", this will limit the number of recent comments shown. i.e. limit="5" shows last 5 comments.

totalwords=
	totalwords="5" (default)
	Choose the number of words that will be displayed from the comment itself. i.e. totalwords="5" will display the first 5 words from the comment.

format=
	format="%m/%d/%y %h:%i" (default)
	Choose the format that the date will show up as, using the traditional EE date formatting features.
	
type=
	type="entries" (default)
	Choose if you wish to have recently commented on entries, or recent comments.
	possible values:
		type="entries" : This will show the most recently commented on entries.
		type="comments" : This will show the most recent comments.
		type="trackbacks" : This will show the most recent trackbacks.

VARIABLES:

{title}
The entry title.

{comment}
The excerpt of the comment made. (limited by the "totalwords" parameter.)

{date}
The date the last comment was made.

{total_comments}
Total number of comments for the entry.

{permalink=}
The link to the entry. Normally used: {permalink="weblog/comments"} or {permalink="SITE_INDEX"}

{title_permalink=}
The link to the entry by title. Normally used: {title_permalink="weblog/comments"} or {title_permalink="SITE_INDEX"}

{name}
The author of the comment.

{author}
The author with a link to their homepage, if any.

{comment_id}
The comment ID

<?php
$buffer = ob_get_contents();
	
ob_end_clean(); 

return $buffer;
}


}
?>